#!/bin/sh

# a bunch of one-line programs i want in my dmenu (and sometimes elsewhere)
# these have use outside the terminal and thus are generated here
# - because why make fifty files when i can make one file that does that for me?

cde() {
	cd $1
	printf "Entered %s.\n" $(pwd)
}

mkdir -p $HOME/bin/oneliners || exit
cde $HOME/bin/oneliners

SHABANG="#!/bin/sh\n"
BASH_SHABANG="#!/bin/bash\n"

DMENU_LINES="40"

TEXTS_LIBRARY="/mnt/partone/texts/"
MUSIC_LIBRARY="/mnt/audio/"

# music stuff
printf $SHABANG"selection=\"\$(find $MUSIC_LIBRARY -type d -mindepth 2 2>/dev/null | sort | dmenu -l $DMENU_LINES)\"\n[ \$selection = \$(printf \"\\n\") ] 2>/dev/null || audacious \"\$selection\"\n" >play_album
printf $SHABANG"selection=\"\$(find $MUSIC_LIBRARY -type f | sort | dmenu -l $DMENU_LINES)\"\n[ \$selection = \$(printf \"\\n\") ] 2>/dev/null || audacious \"\$selection\"\n" >play_song

# reading
printf $SHABANG"SELECTION=\"\$(find $TEXTS_LIBRARY -type f | sort | dmenu -l $DMENU_LINES)\"
EXTENSION=\"\$(echo \$SELECTION | asplit . 1)\"
case \$EXTENSION in
	(djvu) zathura \"\$SELECTION\" ;;
	(epub) zathura \"\$SELECTION\" ;;
	(html) firefox \"\$SELECTION\" ;;
	(pdf)  zathura \"\$SELECTION\" ;;
	(*)    xterm -e \"cat \"\"\$SELECTION\"\" | nl | less\" ;;
esac
" >read_book # broken, xterm things flash and exit 0.

# private bookmarks
printf $SHABANG"firefox file://$HOME/bookmarks.html\n" >bmarks

# deemix
printf $SHABANG"python $HOME/src/deemix-pyweb/deemix-pyweb.py\n" >deemix

# firefox (launches firefox-developer-edition)
printf $BASH_SHABANG"firefox-developer-edition \"\$@\"\n" >firefox

# settings for specific monitors
printf $SHABANG"xrandr --output HDMI-1 --auto --mode 720x480 --right-of LVDS-1\n" >1702
printf $SHABANG"xrandr --output VGA-1 --auto --right-of LVDS-1\n" >mv720

# more monitor settings
printf $SHABANG"xrandr --output HDMI-1 --off\n" >hdmioff
printf $SHABANG"xrandr --output VGA-1 --off\n" >vgaoff

# wireguard vpn stuff
printf $BASH_SHABANG"sudo wg-quick up \"\$@\"\n" >vpn-connect
printf $BASH_SHABANG"sudo wg-quick down \"\$@\"\n" >vpn-disconnect
printf $SHABANG"sudo ls /etc/wireguard/ | grep \"conf$\" | asplit .conf 0\n" >vpn-list
printf $SHABANG"xterm -e \"vpn-connect \$(vpn-list | dmenu); read -s -n 1\"\n" >vpn-quick # not to be confused with wg-quick

# i always forget to use multimc
printf $SHABANG"multimc\n" >minecraft

# project i'm working on
printf $SHABANG"xterm -e \". $HOME/src/ytfeed.py/bin/activate && python $HOME/src/ytfeed.py/cli.py\"\n" >ytfeed
printf $BASH_SHABANG"cd $HOME/src/ytfeed.sh/\n./renew.sh \"\$@\"\n" >ytfeed-renew

# youtube-dl stuff
printf $BASH_SHABANG"youtube-dl --add-metadata -i -o \"$HOME/%%(upload_date)s %%(title)s.%%(ext)s\" \"\$@\"\n" >youtube-dlo
printf $BASH_SHABANG"youtube-dlo -f \"bestvideo[vcodec=vp9]+bestaudio[acodec=opus]\" \"\$@\"\n" >youtube-dlp
printf $BASH_SHABANG"youtube-dlp -f \$(youtube-dl -F \$1 | tail +4 | dmenu -p \"Choose a format.\" -l $DMENU_LINES | awk '{ print \$1 }') \"\$@\"\n" >youtube-dl-interactive
printf $BASH_SHABANG"youtube-dl-interactive \"\$@\" -o - | mpv -\n" >youtube-dl-mpv

ls && [ $(printf "Yes.\nNo." | dmenu -p "Any risky files?") = "No." ] && printf "Making executable.\n" && chmod +x *
